#ifndef __CHROMOSOME_NUMBER_OPTIMIZER
#define __CHROMOSOME_NUMBER_OPTIMIZER

#include "definitions.h"
#include "tree.h"
#include "sequenceContainer.h"
#include "stochasticProcess.h"
#include "chrNumModel.h"



/***********************************************************************
**********************************************************************/
class chrNumOptimizer{
public:
	chrNumOptimizer(const tree &tr, const sequenceContainer &sc);
	~chrNumOptimizer();
	//optimize the model param and return best log-likelihood
	MDOUBLE optimizeModel(stochasticProcess* pSp, MDOUBLE epsilonLLImprovement, int maxIter, MDOUBLE tolParamOptimization);
    MDOUBLE optimizeModelManyStart(stochasticProcess* pSp, const Vint& pointsNum, const Vint& iterNum, const Vdouble& tols);

private:
	stochasticProcess* getRandomProcess(const stochasticProcess* pBaseSp) const;
	MDOUBLE optimizeCombinedSpeciationalModel(stochasticProcess* pSp, MDOUBLE epsilonLLImprovement, int maxIter, MDOUBLE tolParamOptimization);

private:
	tree _tree;
	sequenceContainer _sc;

	MDOUBLE _bestL;
};
#endif
